# $Date: 1995/08/25 19:00:52 $ $Author: kg $ $Revision: 1.14 $ #
#++
Cat::AbelianGroup -- the category of abelian groups

An Cat::AbelianGroup is a Cat::CancellationAbelianMonoid where the operation '+'
is invertible.

Methods:-
negate(x)     - returns the (additive) inverse of x
minus(x,y)    - returns z such that y+z = x
equal(x,y)    - returns TRUE iff x = y
++#

Cat::AbelianGroup:= CategoryConstructor(
    Cat::AbelianGroup,
    [],
    [],
    NIL,
    [ Cat::CancellationAbelianMonoid ],
    [],

    "negate",
    
    "minus" = proc(x,y) begin this::_plus(x, this::negate(y)) end_proc,

    "equal" = proc(x,y) begin
	this::iszero(this::minus(x, y))
    end_proc,

    "intmult" = domains::repeatedSquaring(this, "_plus", "zero", "negate")

)():

